#include "stdafx.h"
#include "Balls.h"
#include "BallsDlg.h"


CBallsDlg::CBallsDlg():CDialog(IDD_BALL_DIALOG)
{
}


BEGIN_MESSAGE_MAP(CBallsDlg, CDialog)
	//{{AFX_MSG_MAP(CBallsDlg)
	ON_WM_PAINT()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CBallsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	GetClientRect(&m_rect);
	m_engine.Init(m_rect);
	SetTimer(0,40,0);
	CPaintDC dc(this);
	m_bitmap.CreateCompatibleBitmap(&dc,m_rect.Width(),m_rect.Height());
	m_dc.CreateCompatibleDC(&dc);
	m_dc.SelectObject(&m_bitmap);
	return TRUE; // return TRUE  unless you set the focus to a control
}


void CBallsDlg::OnPaint() 
{
	int n; const CObj *obj;
	CPaintDC dc(this);
	CBrush *p_brush,*brush;
	m_dc.FillSolidRect(&m_rect,RGB(-50,-1,-1));
	m_dc.MoveTo(m_engine.GetBar().TopLeft());
	m_dc.LineTo(m_engine.GetBar().BottomRight());
	for(n=0; n<m_engine.GetCount(); n++) {
		obj=m_engine.GetObj(n);
		brush=new CBrush(obj->color);
		p_brush=m_dc.SelectObject(brush);
		m_dc.Ellipse(obj->x-obj->r,obj->y-obj->r,obj->x+obj->r,obj->y+obj->r);
		m_dc.SelectObject(p_brush);
		delete brush;
	}
	dc.BitBlt(m_rect.left,m_rect.top,m_rect.Width(),m_rect.Height(),&m_dc,0,0,SRCCOPY);
}


void CBallsDlg::OnTimer(UINT nIDEvent) 
{
	MSG msg;
	for(;;) {
		PeekMessage(&msg,GetSafeHwnd(),0,0,FALSE);
		if(msg.message!=WM_TIMER) break;
		PeekMessage(&msg,GetSafeHwnd(),0,0,TRUE);
	}
	m_engine.Work();
	Invalidate(FALSE);
}
